
import math

class Coord:

    """Class to represent a coordinate in three-space"""

    def __init__(self,x,y,z):
        """Constructor for a coordinate class"""
        self.coord = [x,y,z]

    def x(self):
        return self.coord[0]

    def y(self):
        return self.coord[1]

    def z(self):
        return self.coord[2]


        double operator [] (const int indx) const {
            assert((indx >= 0) && (indx <= 2)) ;
            return(coord[indx]) ;
        } ;

        double &operator[] (const int indx) {
            assert((indx >= 0) && (indx <= 2)) ;
            return(coord[indx]) ;
        } ;

        Coord operator += (const Coord &op2) {
            coord[0] += op2.coord[0] ;
            coord[1] += op2.coord[1] ;
	    coord[2] += op2.coord[2] ;
            return(*this) ;
        } ;

        Coord operator -= (const Coord &op2) {
            coord[0] -= op2.coord[0] ;
            coord[1] -= op2.coord[1] ;
	    coord[2] -= op2.coord[2] ;
            return(*this) ;
        } ;

        Coord operator *= (const double &op2) {
            coord[0] *= op2 ;
            coord[1] *= op2 ;
	    coord[2] *= op2 ;
            return(*this) ;
        } ;

        Coord operator /= (const double &op2) {
            coord[0] /= op2 ;
            coord[1] /= op2 ;
	    coord[2] /= op2 ;
            return(*this) ;
        } ;


    def Magnitude(self):
        """Computes the manitude of the coord vector"""
        return math.sqrt(self.coord[0]*self.coord[0] +
                         self.coord[1]*self.coord[1] +
                         self.coord[2]*self.coord[2])

    def Normalize(self:
        """Returns a normalized version of the coord vector"""
        len = self.Magnitude()
        return Coord(self.coord[0]/len,self.coord[1]/len,
                     self.coord[2]/len)

    def __neg__(self):
        return Coord(-self.coord[0],-self.coord[1],-self.coord[2])

                                                 
inline int operator == (const Coord &c1,const Coord &c2)
{
    return((c1[0] == c2[0]) && (c1[1] == c2[1]) && (c1[2] == c2[2])) ;
}

inline int operator < (const Coord &c1,const Coord &c2)
{
    return((c1[0] <= c2[0]) && (c1[1] <= c2[1]) && (c1[2] <= c2[2])) ;
}

inline int operator > (const Coord &c1,const Coord &c2)
{
    return((c1[0] >= c2[0]) && (c1[1] >= c2[1]) && (c1[2] >= c2[2])) ;
}

    def __add__(self,other):
Check type
        return Coord(self.coord[0]+other.coord[0],
                     self.coord[1]+other.coord[1],
                     self.coord[2]+other.coord[2])

    def __sub__(self,other):
Check type
        return Coord(self.coord[0]-other.coord[0],
                     self.coord[1]-other.coord[1],
                     self.coord[2]-other.coord[2])

    def __mul__(self,other):

    def __div__(self,other):

inline Coord operator * (const Coord &op1,const double &op2)
{
    Coord op = op1 ;
    op *= op2 ;
    return(op) ;
}

inline Coord operator * (const double &op1,const Coord &op2)
{
    Coord op = op2 ;
    op *= op1 ;
    return(op) ;
}

inline double operator * (const Coord &op1,const Coord &op2)
{
    return(op1.x()*op2.x() + op1.y()*op2.y() + op1.z()*op2.z()) ;
}

inline Coord operator / (const Coord &op1,const double &op2)
{
    Coord op = op1 ;
    op /= op2 ;
    return(op) ;
}

inline Coord CrossProd(const Coord &op1,const Coord &op2)
{
    return(Coord((op1.y()*op2.z()) - (op1.z()*op2.y()), 
                 (op1.z()*op2.x()) - (op1.x()*op2.z()), 
                 (op1.x()*op2.y()) - (op1.y()*op2.x()))) ; 
}

inline double TripleProd(const Coord &op1,const Coord &op2,
                         const Coord &op3)
{
    Coord tmp = CrossProd(op1,op2) ;
    return(tmp * op3) ; 
}

inline ostream &operator << (ostream &out,const Coord &coord)
{
    out <<coord.x() << ' ' << coord.y() << ' ' << coord.z() ;
    return(out) ;
}

inline istream &operator >> (istream &in, Coord &coord)
{
    in >> coord[0] >> coord[1] >> coord[2] ;
    return(in) ;
}
 
#endif
