
from distutils.core import setup
from distutils.core import Extension

setup(name="FemLib",
      version="0.8",
      description="Finite Element Formulation Library",
      author="Wash Wawrzynek",
      author_email="wash@stout.cfg.cornell.edu",
      url="http://www.cfg.cornell.edu",
      ext_modules=[Extension("FemLib",["FemLibModule.cc",
                                       "Element.cc",
                                       "IntegrationPts.cc",
                                       "MaterialMat.cc",
                                       "ShapeFunc.cc"],
                             define_macros=[('BAD_STATIC_FORWARD','1')],
                             extra_compile_args=['-g','-pedantic'],
                             extra_link_args=['-g'],
                             libraries=['gcc']
                            ),
                   Extension("SparseCG",["SparseCGModule.cc",
                                         "SparseCG.cc"],
                             define_macros=[('BAD_STATIC_FORWARD','1')],
                             extra_compile_args=['-g','-pedantic'],
                             extra_link_args=['-g'],
                             libraries=['gcc']
                            ),
                   Extension("TableFunction",["TableFunctionModule.cc",
                                              "TableFunction.cc"],
                             define_macros=[('BAD_STATIC_FORWARD','1')],
                             extra_compile_args=['-g','-pedantic'],
                             extra_link_args=['-g'],
                             libraries=['gcc']
                            )],
      py_modules=['Vec3D','ColTensor','SimpleFem','SparseFem']
     )
