
#include <fstream>
 
#include "TableFunction.hh"


int main(int argc,char *argv[])
{

    {
        // case 1: zero data points

        TableFunction tf ;
        double y ;
        bool valid = tf.GetValue(1.0,&y) ;
        cerr << "Empty Table value: " << valid << endl ;
    }

    {
        // case 2: one data points

        double xv = 1.0 ;
        double yv = 10.0 ;
        TableFunction tf(1,&xv,&yv,TableFunction::I_LINEAR,
                         TableFunction::E_NONE) ;
        double y = 0.0 ;
        double x = 0.5 ;
        cerr << "One pt, I_LINEAR, E_NONE: " << endl ;

        bool valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
 
        x = 1.0 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
 
        x = 1.5 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        tf.Configure(1,&xv,&yv,TableFunction::I_LINEAR,
                         TableFunction::E_CONSTANT) ;
        y = 0.0 ;
        x = 0.5 ;
        cerr << "One pt, I_LINEAR, E_CONSTANT: " << endl ;

        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
 
        x = 1.0 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
 
        x = 1.5 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        tf.Configure(1,&xv,&yv,TableFunction::I_LINEAR,
                         TableFunction::E_LINEAR) ;
        y = 0.0 ;
        x = 0.5 ;
        cerr << "One pt, I_LINEAR, E_LINEAR: " << endl ;

        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
 
        x = 1.0 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
 
        x = 1.5 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
    }

    cerr << endl ;

    {
        // case 3: two data points

        double xv[] = {1.0, 2.0} ;
        double yv[] = {10.0,20.0} ;
        TableFunction tf(2,xv,yv,TableFunction::I_LINEAR,
                         TableFunction::E_NONE) ;
        double y = 0.0 ;
        double x = 0.5 ;
        cerr << "Two pts, I_LINEAR, E_NONE: " << endl ;

        bool valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
 
        x = 1.0 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
 
        x = 1.5 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        x = 2.0 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        x = 2.5 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        tf.Configure(2,xv,yv,TableFunction::I_LINEAR,
                         TableFunction::E_CONSTANT) ;
        y = 0.0 ;
        x = 0.5 ;
        cerr << "Two pts, I_LINEAR, E_CONSTANT: " << endl ;

        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
 
        x = 1.0 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
 
        x = 1.5 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        x = 2.0 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        x = 2.5 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        tf.Configure(2,xv,yv,TableFunction::I_LINEAR,
                         TableFunction::E_LINEAR) ;
        y = 0.0 ;
        x = 0.5 ;
        cerr << "Two pt, I_LINEAR, E_LINEAR: " << endl ;

        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
 
        x = 1.0 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
 
        x = 1.5 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        x = 2.0 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        x = 2.5 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        tf.Configure(2,xv,yv,TableFunction::I_SPLINE,
                         TableFunction::E_LINEAR) ;
        y = 0.0 ;
        x = 0.5 ;
        cerr << "Two pt, I_SPLINE, E_LINEAR: " << endl ;

        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
 
        x = 1.0 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
 
        x = 1.5 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        x = 2.0 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        x = 2.5 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
    }

    cerr << endl ;

    {
        // case 4: three data points

        double xv[] = {1.0, 3.0, 2.0} ;
        double yv[] = {10.0,10.0,20.0} ;
        TableFunction tf(3,xv,yv,TableFunction::I_LINEAR,
                         TableFunction::E_LINEAR) ;
        double y = 0.0 ;
        double x = 0.5 ;
        cerr << "Three pts, I_LINEAR, E_LINEAR: " << endl ;

        bool valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
 
        x = 1.0 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
 
        x = 1.5 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        x = 2.0 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        x = 2.5 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        x = 3.0 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        x = 3.5 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        tf.Configure(3,xv,yv,TableFunction::I_SPLINE,
                         TableFunction::E_LINEAR) ;
        y = 0.0 ;
        x = 0.5 ;
        cerr << "Three pts, I_SPLINE, E_LINEAR: " << endl ;

        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
 
        x = 1.0 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
 
        x = 1.5 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        x = 2.0 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        x = 2.5 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        x = 3.0 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

        x = 3.5 ;
        valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;

    }

    {
        // case 5: bug

        double xv[] = {2.0,  2.1, 22.0, 22.1} ;
        double yv[] = {6.0, 11.0, 11.0, 16.0} ;
        TableFunction tf(3,xv,yv,TableFunction::I_LINEAR,
                         TableFunction::E_CONSTANT) ;
        double y = 0.0 ;
        double x = 2.0 ;
        cerr << "Bug test: " << endl ;

        bool valid = tf.GetValue(x,&y) ;
        cerr << "  x: " << x << " valid : " << valid << " y: " << y << endl ;
    } 
}

